package com.softweb.iotconnectdemo;


import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.widget.Toast;

import com.iotconnectsdk.IoTConnectSDK;
import com.iotconnectsdk.interfaces.IotSDKCallback;
import com.iotconnectsdk.webservices.responsebean.HubToSdkDataBean;
import com.iotconnectsdk.webservices.responsebean.SyncServiceResponse;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

public class IOTConnect_SDK_Sample extends AppCompatActivity implements IotSDKCallback {

    IoTConnectSDK iotConnect;// = new IoTConnectSDK();

    String  cpId = "";//<< CPID >>";
    String uniqueId = "";//"<< Device UniqueID >>";
    String env = "";//"<< Environment >>";
    public static String getCurrentTime() {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        return sdf.format(new Date());
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
		
		iotConnect = new IoTConnectSDK(IOTConnect_SDK_Sample.this,cpId, uniqueId,
                IOTConnect_SDK_Sample.this, env);

        Button btnSendData = (Button) findViewById(R.id.btnSendData);
        btnSendData.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(checkValidation())
                {  
			
					String sendTeledata = "[{\"uniqueId\":\"\",\"time\" : \"2020-09-17T10:06:17.857Z\"," +
                            "\"data\": {\"Temp\": 15.55,\"humidity\" : 27.97,\"Gyroscope\" : {\"x\": -1.2,\"y\" : 0.25,\"z\" : 1.1}}}]";

                        if (iotConnect != null) {
                            iotConnect.sendData(sendTeledata);
                            Log.e("json", "" + sendTeledata);
                            Toast.makeText(IOTConnect_SDK_Sample.this, "Data Sent", Toast.LENGTH_SHORT).show();
                        }

                }
            }
        });

       
    }

    private boolean checkValidation() {
        if (cpId.isEmpty()) {
            Toast.makeText(IOTConnect_SDK_Sample.this, "cpId can not be blank.", Toast.LENGTH_LONG).show();
            return false;
        } else if (uniqueId.isEmpty()) {
            Toast.makeText(IOTConnect_SDK_Sample.this, "uniqueId can not be blank.", Toast.LENGTH_LONG).show();
            return false;
        }else if (env.isEmpty()) {
            Toast.makeText(IOTConnect_SDK_Sample.this, "env can not be blank.", Toast.LENGTH_LONG).show();
            return false;
        }
        return true;
    }

    @Override
    public void onReceiveMsg(HubToSdkDataBean dataBean) {
        if (dataBean != null) {
            Log.e("onReceiveMsg", dataBean.getValue());

        }
    }

    @Override
    public void attributeData(List<SyncServiceResponse.DBeanXX.AttBean> attributesBeanList) {

    }

    @Override
    public void onConnectionStateChange(boolean isConnected) {
        if (isConnected) {
            Log.e("onConnectionStateChange", "Device connected");
        } else {
            Log.e("onConnectionStateChange", "Device disconnected");
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (iotConnect != null) {
            iotConnect.disconnectSDK();
        }
    }
}
